--[[

Changes by sarf:

Added auto-config support. Will be determined on each cast (should not be a penalty).

Added out-of-range-check (requires that DD Action is present).

Added DoT check (for the "Shadow Word: Pain"/"Curse of Agony" spell).

--

Added Mana Spring totem

Removed Warlock DoTs

Added an optional DD Effect checking for the debuffs too (and hence restructured the UnitIsMarkedForDeath thingies).

]]--

--[[
Kill de totemz.

Edit with your own spell/shot if you need to, in the variables.

This is quick and dirty, by all means toss me a line at evilsmoo@gmail.com if you have a better idea.




Fire Blast(Rank 1) (for mages?)
Shoot Bow(Rank 1)  (for non-hunter guns?  need to test further.)


UnitClass("unit") - Returns the class name of the specified unit (e.g., "Warrior" or "Shaman").
   in case you want to set it up to use different spells by class....
]]

-- ***********************************


-- *******

-- End variables.

-- Variables
TKill = { };
TKill.Retarget = true;  --Change this to false if you don't want to target your last enemy
TKill.TempTarget = "";
TKill.Hostile = false;
--I'd suggest using a fast-cast spell with as little cooldown as possible.
--Not sure about hunters, though...  :/   A shot spell works, but annoying cooldown.

-- This function will cast an appropriate spell from the spell list. 
-- It will even be able (with DynamicData Spell) to use "backup" spells in the case where a spell has a cooldown.
function TKill_CastSpell()
	local class = UnitClass("player");
	local inRange = false;
	if ( class ) and ( TKill_Spells[class] ) then
		for k, v in TKill_Spells[class] do
			inRange = true;
			if ( DynamicData ) and ( DynamicData.action ) and ( DynamicData.action.getSpellAsActionId ) then
				local actionId = DynamicData.action.getSpellAsActionId(v);
				if ( actionId ) and ( actionId >= 1 ) and ( IsActionInRange(actionId) ~= 1 ) then
					inRange = false;
				end
			end
			if ( inRange ) then
				if ( DynamicData ) and ( DynamicData.spell ) and ( DynamicData.spell.getMatchingSpellId ) then
					local spellId = DynamicData.spell.getMatchingSpellId(v, 1);
					if ( spellId ) then
						local start, duration, enable = GetSpellCooldown(spellId, BOOKTYPE_SPELL);
						if ( ( start+duration ) <= 0 ) then
							CastSpell(spellId, BOOKTYPE_SPELL);
							return true;
						end
					end
				else
					CastSpellByName(v..TKill_Rank_String);
					return true;
				end
			end
		end
	end
	return false;
end



function TKill_OnLoad()

	-- Register for Events
	this:RegisterEvent("VARIABLES_LOADED");

	-- Register Slash Commands
	SLASH_TKILL1 = "/tkill";
	SlashCmdList["TKILL"] = function( msg )
		TKill_Kill();
	end
	DEFAULT_CHAT_FRAME:AddMessage("Totem Killer Active.");
	
	-- Set spell by class (default is druid  ;)
	--Self_Class = UnitClass("player");
	--Spellname = Class_Spells.Self_Class;
	
end

function TKill_OnEvent()
	-- I'll probably put the class-check here.  Somehow...  Hrmm.
	-- Save Variables
	if ( event == "VARIABLES_LOADED") then
		--RegisterForSave("TKill");  --no point yet, since they are hardcoded....
	end
end	

function TKill_UnitIsMarkedForDeath_DD_Effect(unit, debuffsList)
	if ( not unit ) or ( not debuffsList ) then
		return false;
	end
	if ( not DynamicData ) or ( not DynamicData.effect ) or ( not DynamicData.effect.hasEffectInfo ) then
		return false;
	end
	
	for k, debuffData in debuffsList do
		-- we could specify texture too, but there is no need to, besides, textures may change but names will (hopefully) stay the same
		if ( DynamicData.effect.hasEffectInfo(unit, debuffData.name) ) then
			return true;
		end
	end
	return false;
end

-- Will detect if a DoT is on the totem and if so, skip it.
function TKill_UnitIsMarkedForDeath(unit)
	if ( not unit ) then
		return false;
	end
	-- performance increase - will only check for debuffs on classes that need it
	local class = UnitClass("player");
	if ( not class ) then
		return false;
	end
	local list = TKill_UnitIsMarkedForDeath_Data[class];
	if ( not list ) then
		return false;
	end
	if ( DynamicData ) and ( DynamicData.effect ) and ( DynamicData.effect.hasEffectInfo ) then
		return TKill_UnitIsMarkedForDeath_DD_Effect(unit, list);
	end
	
	local i = 1;
	local debuff = UnitDebuff(unit, i);
	while debuff do
		for k, v in list do
			if ( string.find(debuff, v.texture) ) then
				return true;
			end
		end
		i = i + 1;
		debuff = UnitDebuff(unit, i);
	end
	return false;
end

function TKill_Kill()	-- You get the idea.  Check if it exists, if it does, kill.
	TKill.Hostile = false;
	TKill.TempTarget = UnitName("target");
	if UnitIsEnemy("player", "target") then
		TKill.Hostile = true;
	else
		TKill.Hostile = false;
	end
	--DEFAULT_CHAT_FRAME:AddMessage("ttarg is "..TKill.Temptarget.." forsooth!");  --debug
	for k, v in TKill_TotemList do --this way, you can add to the array easily
		TargetUnit("player");
		TargetByName(v);
		--DEFAULT_CHAT_FRAME:AddMessage(v);  --only for debug.  very spammy.
		if ( not UnitIsDead("target") ) 
			and ( UnitIsEnemy("player", "target") ) 
			and ( not UnitIsPlayer("target") ) 
			and ( not TKill_UnitIsMarkedForDeath("target") )
			then
			TKill_CastSpell();  --Wham goes here.
			if ( TKill.Retarget and TKill.TempTarget ~= nil ) then 
				TargetByName(TKill.TempTarget);
			else
				ClearTarget();
			end
			return;
		end
		if TKill.Hostile then
			TargetLastEnemy();
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("Nothing found to kill.");
	if TKill.Hostile then
		return;
	end
	if ( TKill.Retarget and TKill.TempTarget ~= nil ) then 
		TargetByName(TKill.TempTarget);
	else
		ClearTarget();
	end
end